module alu16(reset, tclk, ir, select, acc, latch, c, z, d_bus);
input	reset, tclk;
input [9:0]		select;
input [15:0]	ir;
output [15:0]	acc, latch;
output			z, c;
inout [15:0]	d_bus;
reg				c, sc, z, sz;
reg [15:0]		acc, sacc, latch;

always	@(posedge tclk or posedge reset) begin
	if (reset) begin acc<=0; latch<=0; c<=0; z<=0; end
	else begin
		if(select[5]) begin
			casex(ir[15:12])
				4'b0000: begin {c,latch}<=acc + d_bus; z<=((acc + d_bus)==16'h0000); end
				4'b0001: begin {c,latch}<=acc - d_bus; z<=((acc - d_bus)==16'h0000); end
				4'b0010: begin {c,latch}<=~(acc & d_bus); z<=(~(acc & d_bus)==16'h0000); end
				4'b0011: begin {c,latch}<=acc << 1; z<=((acc <<1 )==16'h0000); end
				4'b1110: begin sacc<=acc; sc<=c; sz<=z; end
				4'b1111: begin acc<=sacc; c<=sc; z<=sz; end
				default: latch<=acc;
			endcase
		end
		if(select[6]) acc<=d_bus;
	end
end
assign d_bus= (select[1]) ? latch: 16'bz;
endmodule