module mem16(tclk, a_bus, inp, oup, select, d_bus);
input tclk;
input [11:0] a_bus;
input [15:0] inp;
input [9:0] select;
output [15:0] oup;
inout [15:0] d_bus;
reg [15:0] mem[6:6] ;	// max size ... [0:4095]
reg [15:0] oup;

function [15:0] memout;  // memory read
input [11:0] a_bus;
	case(a_bus) 
		0:memout =16'h8FFE;		// LD   FFEH	ROM area
		1:memout =16'h0006;		// ADD  006H
		2:memout =16'h9FFF;		// ST   FFFH
		3:memout =16'h2006;		// NAND 005H
		4:memout =16'hB000;		// JPNZ 000H
		5:memout =16'h0000;		// DB 00 00H
		3840:memout =16'hE000;	// PUSH	  		interupt routine
		3841:memout =16'h8FFE;	// LD FFEH
		3842:memout =16'h9006;	// ST 006H
		3843:memout =16'hF000;	// PULL
		3844:memout =16'hD000;	// RET
		4094:memout =inp;		// input port
		default: memout = mem[a_bus];
	endcase
endfunction 

always @(posedge tclk) begin
	if(select[2] & select[1]) // memory write
		if (a_bus==4095) oup<=d_bus; // output port
			else mem[a_bus]<=d_bus;
end
assign d_bus = (~select[2] & ~select[1])? memout(a_bus): 16'bz;

endmodule