module pcir16(reset, tclk, halt, pc, ir, a_bus, d_bus, select);
input reset, tclk;
input [9:0] select;
input [15:0] d_bus;
output halt;
output [11:0] a_bus;
output [11:0] pc;
output [15:0] ir;
reg [11:0] pc, as;
reg [15:0] ir;

always @(posedge tclk or posedge reset) begin
	if (reset) begin pc<=0; ir<=0; end 
	else begin
		if(select[4]) begin
			if(~select[8] & ~select[7]) pc<=pc+12'b1;
			if(~select[8] & select[7]) pc<=ir[11:0];
			if(select[8] & ~select[7]) pc<=as;
			if(select[8] & select[7]) pc<=12'hf00;
		end
		else if(select[9]) as<=pc;
		else if(select[3]) ir<=d_bus;
	end
end
assign a_bus=(select[0]) ? pc: ir[11:0];
assign halt=(ir==12'hfff);

endmodule